# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'

%define _with_repolib 1

%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/xjavadoc/1.1-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section        free

Name:           xjavadoc
Version:        1.1
Release:        6%{?dist}
Epoch:          0
Summary:        The XJavaDoc engine
License:        BSD
URL:            http://xdoclet.sourceforge.net/xjavadoc/
Group:          Development/Testing
# cvs -d:pserver:anonymous@cvs.sourceforge.net:/cvsroot/xdoclet login
# cvs -z3 -d:pserver:anonymous@cvs.sourceforge.net:/cvsroot/xdoclet export -r XJAVADOC_1_1 xjavadoc
Source0:        %{name}-src-%{version}.tar.gz
Source1:        xjavadoc-component-info.xml
Patch0:         %{name}-build_xml.patch
Requires:       jakarta-commons-logging
Requires:       jakarta-commons-collections
Requires:       xml-commons-jaxp-1.3-apis
Requires:       log4j
Requires:       xalan-j2
BuildRequires:  ant >= 0:1.5
BuildRequires:  ant-junit
BuildRequires:  ant-nodeps
BuildRequires:  jakarta-commons-logging
BuildRequires:  jakarta-commons-collections
BuildRequires:  java-devel
BuildRequires:  jrefactory
BuildRequires:  junit
BuildRequires:  javacc
BuildRequires:  log4j
BuildRequires:  xalan-j2
BuildRequires:  xml-commons-jaxp-1.3-apis
%if %{gcj_support}
BuildRequires:  java-gcj-compat-devel
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The XJavaDoc engine is a complete rewrite of Sun's 
JavaDoc engine that is faster and more suited for 
XDoclet (although it is completely standalone). It 
scans java source code and makes information about 
a class available via special java beans that are 
part of the XJavaDoc core. These beans provide the 
same information about a class as Sun's JavaDoc API, 
and some nice extra features. 

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n %{name}
%patch0 -p0 -b .sav
find . -name "*.zip" | xargs -t rm
find . -name "*.jar" | xargs -t rm

build-jar-repository lib \
xalan-j2 \
xalan-j2-serializer \
junit \
javacc \
log4j \
commons-logging \
commons-collections \
xml-commons-apis \
jrefactory \
ant

%build
#FIXME: Fix these binary deps
#BINCLASSPATH=$PWD/lib/ConfigLog4j.jar
export OPT_JAR_LIST=`%{__cat} %{_sysconfdir}/ant.d/{nodeps,junit}`
export CLASSPATH=
%{ant} -Djavacchome=%{_javadir} javadoc

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}%{_javadir}
mkdir -p %{buildroot}%{_javadocdir}
install -m 644 target/%{name}-%{version}.jar %{buildroot}%{_javadir}

# version less symlinks
(cd %{buildroot}%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

#javadoc
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr dist/docs/api/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
install -d -m 755 %{buildroot}%{repodir}
install -d -m 755 %{buildroot}%{repodirlib}
install -m 755 %{SOURCE1} %{buildroot}%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i 's/@TAG@/$tag/g' %{buildroot}%{repodir}/component-info.xml
sed -i 's/@VERSION@/%{version}-brew/g' %{buildroot}%{repodir}/component-info.xml
install -d -m 755 %{buildroot}%{repodirsrc}
install -m 755 %{PATCH0} %{buildroot}%{repodirsrc}
install -m 755 %{SOURCE0} %{buildroot}%{repodirsrc}
cp -p %{buildroot}%{_javadir}/xjavadoc.jar %{buildroot}%{repodirlib}/xjavadoc.jar
%endif

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf %{buildroot}

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi

%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%doc LICENSE.txt docs/architecture.txt
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}/repository.jboss.com
%endif

%changelog
* Mon Apr 13 2009 David Walluck <dwalluck@redhat.com> 0:1.1-6
- fix repolib
- fix xml-commons (Build)Requires

* Wed May 28 2008 David Walluck <dwalluck@redhat.com> 0:1.1-5.jpp5
- sync with 1.1-4jpp
- use %%{_javadir} macro
- use proper %%doc
- remove useless-explicit-provides %%{name}

* Sun Apr 20 2008 David Walluck <dwalluck@redhat.com> 0:1.1-1jpp.ep1.2
- add xalan-j2-serializer
- remove $RPM_BUILD_ROOT check
- remove javadoc scriptlets

* Mon Mar 12 2007 Fernando Nasser <fnasser@redhat.com> 1.1-1jpp.ep1.1
- Rebuild

* Tue Mar 06 2007 Vivek Lakshmanan <vivekl@redhat.com> 1.1-1jpp.el4ep1.3
- Use javadir as the base directory for repolib artifacts

* Mon Mar 05 2007 Fernando Nasser <fnasser@redhat.com> 1.1-1jpp.el4ep1.2
- Remove run-time dependency on jrefactory

* Sun Feb 18 2007 Vivek Lakshmanan <vivekl@redhat.com> 1.1-1jpp.el4ep1.1
- Add repolib support
- Add missing BR on ant-nodeps

* Wed Feb 16 2005 Fernando Nasser <fnasser@redhat.com> 1.1-1jpp_1rh
- Merge with upstream for upgrade

* Tue Feb 15 2005 Ralph Apel <r.apel at r-apel.de> 1.1-1jpp
- upgrade to 1.1
- replace requirement of xml-commons by xml-commons-apis

* Fri Oct 15 2004 Fernando Nasser <fnasser@redhat.com> 1.0.3-2jpp_1rh
- First Red Hat build

* Thu Aug 26 2004 Ralph Apel <r.apel at r-apel.de> 1.0.3-2jpp
- Build with ant-1.6.2

* Fri Jul 02 2004 Ralph Apel <r.apel at r-apel.de> 1.0.3-1jpp
- upgrade to 1.0.3
- just eliminate __GENERATED__ tests because no sources for old xdoclet 
- add xjavadoc javadoc subpackage

* Tue Dec 16 2003 Paul Nasrat <pauln at truemesh.com> 1.0-2jpp
- fix non-versioned symlink typo

* Mon Dec 15 2003 Paul Nasrat <pauln at truemesh.com> 1.0-1jpp
- Initial Release
